Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 832871 - dev-libs/libgcrypt-1.9.4[-asm]: fails to build on hppa1.1 (./.libs/libgcrypt.so: undefined reference to `__udiv_qrnnd')
Summary: dev-libs/libgcrypt-1.9.4[-asm]: fails to build on hppa1.1 (./.libs/libgcrypt....
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: HPPA Linux
: Normal normal (vote)
Assignee: Mikle Kolyada
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2022-02-07 22:45 UTC by Sam James
Modified: 2022-06-15 20:58 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (file_832871.txt,138.99 KB, text/plain)
2022-02-07 22:45 UTC, Sam James
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-02-07 22:45:40 UTC
Created attachment 764554 [details]
build.log

libtool: link: (cd ".libs" && rm -f "libgcrypt.so.20" && ln -s "libgcrypt.so.20.3.4" "libgcrypt.so.20")
libtool: link: (cd ".libs" && rm -f "libgcrypt.so" && ln -s "libgcrypt.so.20.3.4" "libgcrypt.so")
libtool: link: ( cd ".libs" && rm -f "libgcrypt.la" && ln -s "../libgcrypt.la" "libgcrypt.la" )
hppa1.1-unknown-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I/var/tmp/portage/dev-libs/libgcrypt-1.9.4/work/libgcrypt-1.9.4/src -I..     -O2 -pipe -march=1.1 -fvisibility=hidden -fno-delete-null-pointer-checks -Wall -c -o mpicalc-mpicalc.o `test -f 'mpicalc.c' || echo '/var/tmp/portage/dev-libs/libgcrypt-1.9.4/work/libgcrypt-1.9.4/src/'`mpicalc.c
hppa1.1-unknown-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I/var/tmp/portage/dev-libs/libgcrypt-1.9.4/work/libgcrypt-1.9.4/src -I..    -DSTANDALONE  -O2 -pipe -march=1.1 -fvisibility=hidden -fno-delete-null-pointer-checks -Wall -c -o hmac256-hmac256.o `test -f 'hmac256.c' || echo '/var/tmp/portage/dev-libs/libgcrypt-1.9.4/work/libgcrypt-1.9.4/src/'`hmac256.c
/bin/sh ../libtool  --tag=CC   --mode=link hppa1.1-unknown-linux-gnu-gcc  -O2 -pipe -march=1.1 -fvisibility=hidden -fno-delete-null-pointer-checks -Wall  -Wl,-O1 -Wl,--as-needed -o mpicalc mpicalc-mpicalc.o libgcrypt.la -lgpg-error 
libtool: link: hppa1.1-unknown-linux-gnu-gcc -O2 -pipe -march=1.1 -fvisibility=hidden -fno-delete-null-pointer-checks -Wall -Wl,-O1 -o .libs/mpicalc mpicalc-mpicalc.o  -Wl,--as-needed ./.libs/libgcrypt.so -lgpg-error
/usr/lib/gcc/hppa1.1-unknown-linux-gnu/11.2.0/../../../../hppa1.1-unknown-linux-gnu/bin/ld: ./.libs/libgcrypt.so: undefined reference to `__udiv_qrnnd'
collect2: error: ld returned 1 exit status
make[2]: *** [Makefile:751: mpicalc] Error 1
make[2]: Leaving directory '/var/tmp/portage/dev-libs/libgcrypt-1.9.4/work/libgcrypt-1.9.4-.hppa/src'
make[1]: *** [Makefile:502: all-recursive] Error 1
make[1]: Leaving directory '/var/tmp/portage/dev-libs/libgcrypt-1.9.4/work/libgcrypt-1.9.4-.hppa'
make: *** [Makefile:434: all] Error 2
 * ERROR: dev-libs/libgcrypt-1.9.4::gentoo failed (compile phase):
 *   emake failed

----

# emerge --info
Portage 3.0.30 (python 3.9.9-final-0, default/linux/hppa/17.0/systemd, gcc-11.2.1, glibc-2.33-r7, 5.17.0-rc2 parisc64)
=================================================================
System uname: Linux-5.17.0-rc2-parisc64-PA8800_-Mako-with-glibc2.33
KiB Mem:     8206800 total,   1976060 free
KiB Swap:    1122500 total,   1121468 free
Timestamp of repository gentoo: Mon, 07 Feb 2022 20:22:05 +0000
Head commit of repository gentoo: b18b1e06b2a774c6883e953308bbfd77af4fa772

sh dash 0.5.11.5
ld GNU ld (Gentoo 2.37_p1 p2) 2.37
ccache version 4.5.1 [disabled]
app-misc/pax-utils:        1.3.3::gentoo
app-shells/bash:           5.1_p8::gentoo
dev-lang/perl:             5.34.0-r6::gentoo
dev-lang/python:           3.9.9-r1::gentoo, 3.10.0_p1-r1::gentoo
dev-util/ccache:           4.5.1::gentoo
dev-util/cmake:            3.21.4::gentoo
dev-util/meson:            0.60.3::gentoo
sys-apps/baselayout:       2.7-r3::gentoo
sys-apps/sandbox:          2.25::gentoo
sys-apps/systemd:          249.9::gentoo
sys-devel/autoconf:        2.71-r1::gentoo
sys-devel/automake:        1.16.4::gentoo
sys-devel/binutils:        2.37_p1-r2::gentoo
sys-devel/binutils-config: 5.4::gentoo
sys-devel/gcc:             11.2.1_p20220115::gentoo
sys-devel/gcc-config:      2.5-r1::gentoo
sys-devel/libtool:         2.4.6-r6::gentoo
sys-devel/make:            4.3::gentoo
sys-kernel/linux-headers:  5.15-r3::gentoo (virtual/os-headers)
sys-libs/glibc:            2.33-r7::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: git
    sync-uri: https://github.com/gentoo-mirror/gentoo.git
    priority: -1000
    eclass-overrides: local
    sync-git-verify-commit-signature: yes
    sync-git-clone-extra-opts: -b stable -c gc.reflogExpire=0 -c gc.reflogExpireUnreachable=0 -c gc.rerereresolved=0 -c gc.rerereunresolved=0 -c gc.pruneExpire=now

local
    location: /var/db/repos/local
    masters: gentoo
    eclass-overrides: local

ACCEPT_KEYWORDS="hppa"
ACCEPT_LICENSE="@FREE"
CBUILD="hppa2.0-unknown-linux-gnu"
CFLAGS="-O2 -pipe -march=2.0"
CHOST="hppa2.0-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe"
DISTDIR="/var/cache/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS=""
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildpkg-live config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS=""
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j4"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
SHELL="/bin/bash"
USE="acl big-endian bzip2 cli crypt fortran gdbm hppa iconv ipv6 libglvnd ncurses nls nptl openmp pam pcre readline seccomp split-usr ssl systemd udev unicode xattr zlib" ADA_TARGET="gnat_2020" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-4 php8-0" POSTGRES_TARGETS="postgres12 postgres13" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_9" RUBY_TARGETS="ruby26 ruby27" USERLAND="GNU" VIDEO_CARDS="fbdev dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  ADDR2LINE, AR, ARFLAGS, AS, ASFLAGS, CC, CCLD, CONFIG_SHELL, CPP, CPPFLAGS, CTARGET, CXX, CXXFILT, ELFEDIT, EXTRA_ECONF, F77FLAGS, FC, GCOV, GPROF, INSTALL_MASK, LC_ALL, LD, LEX, LFLAGS, LIBTOOL, LINGUAS, MAKE, MAKEFLAGS, NM, OBJCOPY, OBJDUMP, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RANLIB, READELF, RUSTFLAGS, SIZE, STRINGS, STRIP, YACC, YFLAGS
Comment 1 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-02-07 22:46:18 UTC
matt hit this during the livecd-stage1-hppa1.1-20220201T043702Z build
Comment 2 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-02-07 22:47:00 UTC
Not sure if this is ccache related. We've had problems there before.
Comment 3 Matt Turner gentoo-dev 2022-02-07 23:39:56 UTC
So I don't forget: __udiv_qrnnd is a software division routine provided by glibc:

sysdeps/hppa/hppa1.1/udiv_qrnnd.S
sysdeps/hppa/udiv_qrnnd.S

Need to check whether it appears to be exported correctly.
Comment 5 Larry the Git Cow gentoo-dev 2022-05-01 23:11:08 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=faf8e412f95a3becd535017e283158037d78e0a2

commit faf8e412f95a3becd535017e283158037d78e0a2
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-05-01 23:10:48 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-05-01 23:11:01 +0000

    dev-libs/libgcrypt: disable asm for hppa1.1
    
    Closes: https://bugs.gentoo.org/832871
    Signed-off-by: Sam James <sam@gentoo.org>

 dev-libs/libgcrypt/libgcrypt-1.10.1.ebuild   | 5 ++++-
 dev-libs/libgcrypt/libgcrypt-1.8.8.ebuild    | 6 +++++-
 dev-libs/libgcrypt/libgcrypt-1.8.9.ebuild    | 6 +++++-
 dev-libs/libgcrypt/libgcrypt-1.9.4-r1.ebuild | 5 ++++-
 4 files changed, 18 insertions(+), 4 deletions(-)
Comment 6 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-05-12 21:46:43 UTC
Still an issue.
Comment 7 Larry the Git Cow gentoo-dev 2022-05-13 02:57:59 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=918f1e41fbd689749807ff8d2d3a99c4124a50ad

commit 918f1e41fbd689749807ff8d2d3a99c4124a50ad
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-05-13 02:57:22 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-05-13 02:57:22 +0000

    dev-libs/libgcrypt: restore asm usage for HPPA 1.1
    
    It looks like I got it the wrong way around -- USE=-asm is the
    broken thing on HPPA 1.1, not USE=asm.
    
    (This explains why stage builds were acting up, I think, as
    they use USE=-* initially?)
    
    Bug: https://bugs.gentoo.org/832871
    Signed-off-by: Sam James <sam@gentoo.org>

 dev-libs/libgcrypt/libgcrypt-1.9.4-r1.ebuild | 2 --
 1 file changed, 2 deletions(-)
Comment 8 Larry the Git Cow gentoo-dev 2022-06-15 20:58:28 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=b54b910baa46dac7f6f78ca0889799e639becf83

commit b54b910baa46dac7f6f78ca0889799e639becf83
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-06-15 20:58:01 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-06-15 20:58:01 +0000

    dev-libs/libgcrypt: backport -asm patch for HPPA
    
    Closes: https://bugs.gentoo.org/832871
    Signed-off-by: Sam James <sam@gentoo.org>

 .../files/libgcrypt-1.10.1-fix-no-asm-hppa.patch   |  35 ++++++
 dev-libs/libgcrypt/libgcrypt-1.10.1-r1.ebuild      | 128 +++++++++++++++++++++
 2 files changed, 163 insertions(+)